<?php
/*
*	Syndeo CMS (former Site@School)
* 	is a website management system designed for primary schools.
* =============================================================================== *
* History Site@School:
* Original idea, coding (version 1.0) and design : Mark de Haan (mark@starwave.nl)
* Ideas, improvements, expansions (versions 1.1 - 2.4): 
* Karin Abma, Dirk Schouten and Fred Stuurman
* Coding version 1.1 - 2.4.10 Fred Stuurman
* =============================================================================== *
* Syndeo CMS Software Version: 2.6.00  
* Copyright (C) 2007: Fred Stuurman (fc.stuurman@hccnet.nl)
* Album module:
* ALLbum is written by Martin Herrman <m.herrman@student.tue.nl>   
* show_content.php: last changed 21/03/2008 by Fred Stuurman (fc.stuurman@hccnet.nl)
* $Id$
* =============================================================================== *
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License in the starnet directory for more details.
*/

function ShowContent($ID, $gpage, $mode)
{
	// Task: show object with ID $ID, unless it is a hidden object.
	// - When $ID = 0, then a main page must be shown;
	// - When $ID is a (sub-)album, it's contents must be shown;
	// - When $ID is not a (sub-)album or a main page, $gpage is -1. Otherwise,
	//   $gpage is the page number that must be shown.
	//   $mode is 0 when coming from album per page

	global $sas_lang, $page, $sas_config, $section;
	global $category, $allbum_table, $navpath, $cmsdir;
	
	if (IsSet ($_GET['navpath']))
	{
		$navpath = sql_addslashes(strip_tags($_GET['navpath']));
	}
	// Get all details:
	// array[type, title, description, path, thumb, parent, children, hidden]
	$details = db_GetAllDetails($ID);

	// Check if object is hidden:
	if (IsSet ($details[7]) AND ($details[7] == 1))
	{
		// Show 'object is hidden' page:
		echo "<p><span class=\"sas_module_title\">" . $sas_lang['sn_allbum_object_hidden'] . "</span></p>";
		echo "<p><span class=\"sas_module_text\">" . $sas_lang['sn_allbum_object_hidden_text'] . "</span></p>";
		return 0;
	}
	else
	{
		// show navigation path:
		if (IsSet ($_GET['navpath']))
		{
			$navpath = sql_addslashes(strip_tags($_GET['navpath'])) ;
			ShowNavPath($navpath, TRUE);
		}
	}

	$objects = array (
		'sound',
		'movie',
		'doc',
		'unknown',
		'picture'
	);

	if (in_array($details[0], $objects))
	{

		if (IsSet ($_GET['contents']))
		{
			$contents = sql_addslashes(strip_tags($_GET['contents']));
		}
		// **sound-file, movie-file, document-file, unknown-file, picture-file**

		// calculate next and previous object in this (sub-)album:
		$albumcontents = array_clean(explode(",", $contents), "");
		$i = 0;
		
		if(count($albumcontents) > 0)
		{
			while ($albumcontents[$i] != $ID)
			{
				$i++;
			}
		}
		if ($i == count($albumcontents) - 1)
		{
			$nextobjectid = $albumcontents[0];
		}
		else
		{
			$nextobjectid = $albumcontents[$i +1];
		}
		if ($i == 0)
		{
			$prevobjectid = $albumcontents[count($albumcontents) - 1];
		}
		else
		{
			$prevobjectid = $albumcontents[$i -1];
		}

		$title = $details[1];
		// start table
		echo "\n<table class=\"sas_module_table\">";
		echo "<tr><td align=\"right\" width=\"33%\">";
		// YVO: added category
		echo "<a href=\"index.php?page=" . $page . "&amp;navpath=" . $navpath . "&amp;contents=" . $contents . "&amp;section=" . $section . "&amp;category=" . $category . "&amp;ID=" . $prevobjectid . "&amp;gallerypage=1\">
			<img border=\"0\" title=\"" . $sas_lang['sn_allbum_previous_object'] . "\" alt=\"previous\" src=\"$cmsdir/modules/sn_allbum/nav_prev_icon.png\"/></a></td>\n";
		echo "<td align=\"center\" width=\"33%\"><span class=\"sas_module_title\">" . $title . "&nbsp;&nbsp;</span></td>\n";
		echo "<td align=\"left\" width=\"33%\"><a href=\"index.php?page=" . $page . "&amp;navpath=" . $navpath . "&amp;contents=" . $contents . "&amp;section=" . $section . "&amp;category=" . $category . "&amp;ID=" . $nextobjectid . "&amp;gallerypage=1\">
			<img border=\"0\" title=\"" . $sas_lang['sn_allbum_next_object'] . "\" alt=\"next\" src=\"$cmsdir/modules/sn_allbum/nav_next_icon.png\"/></a>\n";
		echo "</td>";
		echo "</tr>\n";

		// Show (image) or (thumb, download link):
		echo "<tr><td colspan=\"3\">";

		if ($details[0] == "picture")
		{
			$query = "SELECT use_size FROM $allbum_table WHERE id = '" . $details[5]. "'"; 	//get use_size from allbum.
			$result = mysql_query($query) or trigger_error(mysql_error().'"<br/>Query : "' . $query . '".',E_USER_WARNING);
			$use_size = mysql_result($result, 0);
			
			$image = str_replace("//", "/", "$cmsdir/" . $details[3] . "/" . $details[4]);
			
			if($use_size == "1") //use the image width/height from the configuration
			{
				// calculate image-width:
				$width = $sas_config['allbum_picsize_x'];
				$size = getimagesize($image);
				if ($size[0] < $size[1])
				{
					// portrait
					$width = $width / 1.3; 
				}
				$width = "width=\"" . $width . "\"";
			}
			else
			{
				$width = "" ;
			}
			// show image
			echo "<div align=\"center\"><img $width alt=\"alt\" src=\"" . $image . "\"/></div>\n";
		}
		else
		{
			// show thumb, download link
			$iconpath = str_replace("//", "/", "$cmsdir/" . $details[4]);
			$filepath = str_replace("//", "/", "$cmsdir/" . $details[3] . "/" . $details[1]);
			echo "  <div align=\"center\"><img alt=\"thumbnail\" src=\"" . $iconpath . "\"/></div>\n";
			echo "  <div align=\"center\"><p><a href=\"" . $filepath . "\" class=\"sas_module_link\">" . $sas_lang['sn_allbum_download_file'] . "</a></p></div>\n";
		}
		echo "  </td>";
		echo "</tr>\n";

		// Show description
		echo "<tr>";
		echo "<td colspan=\"3\" align=\"center\">";
		echo "<span class=\"sas_module_text\">" . $details[2] . "</span><br/><br/>";
		echo "</td>";
		echo "</tr>\n";
		
		if ($details[0] == "picture")	//only show previous next when object is a picture.
		{
		print "<tr><td align=\"right\" width=\"33%\">
				<a href=\"index.php?page=" . $page . "&amp;navpath=" . $navpath . "&amp;contents=" . $contents . "&amp;section=" . $section . "&amp;category=" . $category . "&amp;ID=" . $prevobjectid . "&amp;gallerypage=1\">
				<img border=\"0\" title=\"" . $sas_lang['sn_allbum_previous_object'] . "\" alt=\"previous\" src=\"$cmsdir/modules/sn_allbum/nav_prev_icon.png\"/></a></td>\n
				<td width=\"33%\" align=\"center\"><span class=\"sas_module_lbl2\">".$sas_lang['date']. ": ".$details[11]. "</span></td>
				<td align=\"left\" width=\"33%\"><a href=\"index.php?page=" . $page . "&amp;navpath=" . $navpath . "&amp;contents=" . $contents . "&amp;section=" . $section . "&amp;category=" . $category . "&amp;ID=" . $nextobjectid . "&amp;gallerypage=1\">
				<img border=\"0\" title=\"" . $sas_lang['sn_allbum_next_object'] . "\" alt=\"next\" src=\"$cmsdir/modules/sn_allbum/nav_next_icon.png\"/></a></td>\n
				</tr>\n";
		}
		// end table
		echo "</table>\n";

		return 0;
	}

	$objects = array (
		'album',
		'subalbum'
	);

	if (in_array($details[0], $objects))
	{
		// **(sub-)album**
		// Show title and description:
		echo "<table class=\"sas_module_table\"><tr><td><span class=\"sas_module_title\">" . $details[1] . "</span></td>";
		//see if we have pictures in the album
		$query = "SELECT id FROM $allbum_table WHERE parent = '$ID' and type = 'picture'";
		$result = mysql_query($query) or trigger_error(mysql_error().'"<br/>Query : "' . $query . '".',E_USER_WARNING);
		$RecordCount = mysql_num_rows($result);
		if ($RecordCount > 0) //if so display the slideshow link.
		{
			echo "<td align=\"right\">
					<a href=\"index.php?page=" . $page . "&amp;section=" . $section . "&amp;category=" . $category . "&amp;option=slideshow&amp;ID=" . $ID . "\" class=\"sas_module_link\">
					" . $sas_lang['sn_allbum_show_slideshow'] . "</a></td></tr>";
		}
		echo "<tr><td colspan=\"2\"><span class=\"sas_module_text\">" . $details[2] . "</span></td></tr>";

		// Start table:
		echo "<tr><td colspan=\"2\"><table width=\"98%\" border=\"0\">";

		// Get the id's of all objects in (sub-)album with id $ID:
		// (an array is returned)
		$contents = db_GetVisibleContents($ID, $mode);

		// Check if the list of children is empty:
		$num = count($contents);
		if ($num == 0)
		{
			echo "<tr><td colspan=\"2\"><p><span class=\"sas_module_text\">" . $sas_lang['sn_allbum_empty_album'] . "</span></p></td></tr>";
		}
		else
		{
			// Calculate which children should be shown on page $gpage:
			$show = array ();
			$max_objects_per_page = $sas_config['allbum_max_objects_per_page'];
			for ($i = (($gpage -1) * $max_objects_per_page) + 1;($i <= ($gpage * $max_objects_per_page)) AND ($i <= $num); $i++)
			{
				array_push($show, $contents[$i -1]);
			}

			// make a ?-dimensional array of $show (depending on the configuration option):
			$numperrow = $sas_config['allbum_num_objects_per_row'];
			$showmultipledimensions = array_chunk($show, $numperrow);

			// Show each object:
			$x = $sas_config['allbum_thumbsize_x'];
			$w = 100 / $numperrow;
			foreach ($showmultipledimensions AS $key => $value)
			{

				echo "<tr>";
				$j = $numperrow;
				$i = 0;
				while ($i < $j)
				{
					// Show object (if available):
					if (IsSet ($value[$i]))
					{
						RenderSubAlbumImageCell($value[$i], $x, $numperrow, $navpath . "," . $ID, implode(",", $contents));
					}
					else
					{
						// Show empty cell:
						echo "<td width=\"" . $w . "\">&nbsp;</td>";
					}
					$i++;
				}
				echo "</tr>";

				echo "<tr>";
				$i = 0;
				while ($i < $j)
				{
					// Show object (if available):
					if (IsSet ($value[$i]))
					{
						RenderSubAlbumTitleCell($value[$i]);
					}
					else
					{
						// Show empty cell:
						echo "<td>&nbsp;</td>";
					}
					$i++;
				}
				echo "</tr>";

				// show empty row for some extra space:
				echo "<tr><td colspan=\"" . $numperrow . "\">&nbsp;</td></tr>";

			}

			ShowPreviousNext($ID, $gpage, $num, $max_objects_per_page, $numperrow, true);

		}

		// End table
		echo "</table></td></tr></table>";

		return 0;

	}

	if ($details[0] == 'main')
	{

		// **main-page**

		// show page title:
		echo "<p><span class=\"sas_module_title\">" . $sas_config['allbum_welcome'] . "</span></p>";

		// start table:
		echo "<table class=\"sas_module_table\">";

		// Get list of main albums:
		$contents = db_GetVisibleContents($ID, $mode);

		// Check if list of main albums is empty:
		$num = count($contents);

		if ($num == 0)
		{
			echo "<tr><td colspan=\"2\"><p><span class=\"sas_module_text\">" . $sas_lang['sn_allbum_no_main_albums_avail'] . "</span></p></td></tr>";
		}
		else
		{
			// Calculate which albums should be shown on page $page:
			$show = array ();
			$max_objects_per_page = $sas_config['allbum_max_allbums_per_page'];
			for ($i = (($gpage -1) * $max_objects_per_page) + 1;($i <= ($gpage * $max_objects_per_page)) AND ($i <= $num); $i++)
			{
				array_push($show, $contents[$i -1]);
			}
			// Show each album:
			$x1 = $sas_config['allbum_thumbsize_x'];
			foreach ($show AS $key => $value)
			{

				// Get all details array(type, title, description, path, thumb, parent, children, hidden):
				$details = db_GetAllDetails($value);
				if (file_exists("$cmsdir/" . $details[4])) //thumb is a sound.gif, winmedia.gif etc
				{
					$path = "$cmsdir/" . $details[4];
				}
				else //thumb is a picture
					{
					$thumb = ListThumb("$cmsdir/" . $details[3] . "/" . $details[4]);
					if (file_exists($thumb))
					{
						$path = $thumb;
					}
					else
					{
						$image = "$cmsdir/" . $details[3] . "/" . $details[4];
						if (file_exists($image))
						{
							$path = MakeThumb($thumb, $image); //create the thumb
						}
						else
						{
							print $sas_lang['sn_allbum_err'] . $sas_lang['sn_allbum_file_not_exists'] . "<b>" . $image . "</b>";
						}
					}
				}
				// Show album:
				echo "<tr>
						<td align=\"center\" width=\"40%\">
						<a href=\"index.php?page=" . $page . "&amp;section=" . $section . "&amp;category=" . $category . "&amp;navpath=" . $navpath . "&amp;ID=" . $value . "&amp;gallerypage=1\">
						<img alt=\"alt\" src=\"" . $path . "\" width=\"" . $x1 . "\"/></a>
						</td>
						<td width=\"60%\">
						<span class=\"sas_module_lbl1\">" . $details[1] . "</span>
						<br/><span class=\"sas_module_text\">" . $details[2] . "</span>
						</td>
					  </tr>";
			}

			ShowPreviousNext($ID, $gpage, $num, $max_objects_per_page, 2, true);

		}
		// End table:
		echo "</table>";

		return 0;

	}
}
?>